#ifndef _EXCEPTION_H
#define _EXCEPTION_H

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#define EXCEPTION_TYPE_RET  1
#define EXCEPTION_TYPE_EXIT 2

#define EXCEPTION_STRING_MAXLEN 1024
#define EXCEPTION_ARGS int ret, const char *fmt, ...

#define DEFINE_EXCEPTION(name) int name (EXCEPTION_ARGS)
typedef int EXCEPTION(EXCEPTION_ARGS);

DEFINE_EXCEPTION(exception_null);
DEFINE_EXCEPTION(exception_ret);
DEFINE_EXCEPTION(exception_exit);

#endif /* _EXCEPTION_H */
