/* only compare the last two edges */
/* '>'  -> '>=' */

/* input arguments, 95 % -> t, different edge, N, N/N  */
/* To find number N such that 60%,65%,....95% */

/*
 *  P_threathold
 *  target %
 *  init value for analysis
 *  number of node
 *  localTrafficRate[numOfNode]:
 localTrafficRate of the furtherest node
 :
 :
 localTrafficRate of the closest node
*/

#include <router/ddos/traceback/traceback.h>

double calMinStableTime (double markp,
                         double target,
                         double init_end,
                         int maxd,
                         double* localTrafficRate)
{
/*	int initrange=0,maxrange=1001,router=8; */
	int i,j,d,k,maxk;
	double tempt,maxt;
	double curt,init_start=0.0000001,start,end;
	double accurate;
	double accl[30];
	mpf_t a[30],b[30],c[30],t[30],p[30],sum[30];
	mpf_t result,temp,temp2,diff,temp_result[30];

	d = maxd;
	for (i=0;i<d;i++){
		accl[i] = 0.0;
		mpf_init(a[i]);
		mpf_init(b[i]);
		mpf_init(c[i]);
		mpf_init(t[i]);
		mpf_init(p[i]);
		mpf_init(sum[i]);
		mpf_init(temp_result[i]);
	}
	mpf_init(result);
	mpf_init(temp);
	mpf_init(temp2);
	mpf_init(diff);


/*	for (l=200;l<=200;l++){  */
  for (i=0;i<maxd;i++){
    /* accl[i] = ((atoi(argv[i+2])+l)*10);  */
    accl[i] = 0;
    for (j=i;j<maxd;j++){
      accl[i] += localTrafficRate[j];
    }
  }

  maxt = 0.0;
  for (d=2;d<=maxd;d++){
    mpf_set_d(temp2,target);
    start = init_start;
    end = init_end;
    accurate = 0.0001;


    while (1){
      curt = (start+end)/2;
      for (i=d-2;i<d;i++){
        tempt = accl[i]*curt*markp*pow(1-markp,i);
        mpf_set_d(t[i],tempt);
      }
      maxk = ((int)(3*accl[d-2]*curt*markp*pow(1-markp,d-2)));
      //printf("maxk=%d\n",maxk);
      if (maxk < 100)
        maxk = 100;

      mpf_set_d(result,1);
      for (i=d-2;i<d;i++){ 
        if (accl[i] != 0){
          poisson(0,&t[i],0,&a[i],&b[i],&c[i],&p[i],&sum[i]);
          /* poisson(0,&t[i],d-1-i,&a[i],&b[i],&c[i],&p[i],&sum[i]); */
          mpf_mul(result,result,sum[i]);
        }
        mpf_set_d(temp_result[i],0);
      }
      for (k=1;k<=maxk;k++){ 
				/* for (k=d;k<=maxk;k++){  */
        for (i=d-1;i>=d-2;i--){
					/* for (i=d-1;i>=0;i--){ */
          if (accl[i] != 0){
            poisson(2,&t[i],k,&a[i],&b[i],&c[i],&p[i],&sum[i]);
            /* poisson(2,&t[i],k-i,&a[i],&b[i],&c[i],&p[i],&sum[i]); */
            if (i != d-1){
              mpf_mul(temp,temp_result[i+1],sum[i]);
              mpf_add(temp_result[i],temp_result[i],temp);
            }
            else{
              mpf_add(temp_result[i],temp_result[i],sum[i]);
            }
          }
          else{
            if (i != d-1){
              mpf_add(temp_result[i],temp_result[i],temp_result[i+1]);
            }
            else{
              mpf_set_d(temp_result[i],1);
            }
          }
        }
      }

      /* mpf_add(result,result,temp_result[0]);  */
      mpf_add(result,result,temp_result[d-2]);


      if (fabs(start-end) <= 0.0001){
        accurate = accurate + 0.00005;
        /* printf ("accurate=%.5f\n",accurate); */
        start = init_start;
        end = init_end;
        continue;
      }
      mpf_reldiff(diff,result,temp2);
      if (mpf_cmp_d(diff,accurate)<=0){
        break;
      }
      mpf_sub(diff,result,temp2);
      /* gmp_printf ("__%.*Ff, %.*Ff, %.*Ff\n",5,diff,5,result,5,temp2); */
      if (mpf_cmp_d(diff,0.0)>0){
        end = (start + end)/2;
      }
      else{
        start = (start + end)/2;
        if (ceil(start)>= init_end){
          printf("-1\n");
          return -1;
        }
      }
      /* gmp_printf ("___%.*Ff %.5f\n",4,result,curt); */
    }

    if (curt > maxt)
      maxt = curt;
		/*	gmp_printf ("%.*Ff %.2f\n",4,result,curt);  */
		/*	printf("%s %.4f\n",argv[atoi(argv[d+1])+1],curt); */
  } 
  //printf("%.5f\n",maxt);
  return maxt;
/*	} */

}

int poisson(int op,mpf_t *t,int maxk,mpf_t *a, mpf_t *b, mpf_t *c, mpf_t *p, mpf_t *sum){
	int i,k; 
	double remain;


	if (op == 2){
		mpf_mul(*a, *a, *t);
		mpf_mul_ui(*b, *b, maxk);
		mpf_mul(*sum, *a, *c);
		mpf_div(*sum, *sum, *b);
		return 0;
	}

	if (op == 3){
		mpf_mul(*a, *a, *t);
		mpf_mul_ui (*b, *b, maxk);
		mpf_mul(*p, *a, *c);
		mpf_div(*p, *p, *b);
		mpf_add(*sum,*sum, *p);
		return 0;
	}


	mpf_set_ui (*a, 1);
	mpf_set_ui (*b, 1);

	mpf_floor(*sum,*t);
	mpf_sub(*p,*t,*sum);
	remain = mpf_get_d(*p);
	mpf_set_d(*p,exp(remain));
	mpf_set_d(*c,exp(1));
	i = mpf_get_ui(*sum);
	mpf_pow_ui(*c,*c,i);
	mpf_mul(*c,*c,*p);
	mpf_ui_div(*c,1,*c);
	
/*	mpf_set_d(*c,exp(-mpf_get_d(*t))); */ /* t cannot too small */
/*	gmp_printf ("%.*Ff\n",20, *c); */


	mpf_set_ui (*sum, 0);

	for (k=0;k<=maxk;k++){
		if (k == 0){
			mpf_set(*p, *c);
			if (op == 1){
				mpf_add(*sum, *sum, *p);
			}
			/* gmp_printf ("%.*Ff\n",20, *p); */
			continue;
		}

		mpf_mul(*a, *a, *t);
		mpf_mul_ui (*b, *b, k);
		mpf_mul(*p, *a, *c);
		mpf_div(*p, *p, *b);
		if (op == 1){
			mpf_add(*sum, *sum, *p);
		}
		/* gmp_printf ("%.*Ff\n",20, *p); */
	}
  if (op == 0){
		mpf_set(*sum, *p);
	}
	/* gmp_printf ("%.*Ff\n",20, sum); */


	return 0;
}
